#include <stdio.h>
#include "sctllinux.h"

int
main(int argc, char *argv[])
{
	Ctl *ctl;
	Launch l;
	Trace t;
	Event *e;
	char *args[1];
	char *err;
	unsigned i;

	sctlinit();
	memset(&l, 0, sizeof(Launch));
	l.narg = 1;
	l.argv = args;
	args[0] = "../sctl";
	ctl = launch(&l, &err);
	if(ctl == 0){
		fprintf(stderr, "launch: %s\n", err);
		exit(1);
	}
	t.flags = Eset|Estepctx;
	if(0 > ctltrace(ctl, &t, &err)){
		fprintf(stderr, "trace: %s\n", err);
		exit(1);
	}
	i = 0;
	while(1){
		if(0 > ctlstep(ctl, &err)){
			fprintf(stderr, "step: %s\n", err);
			exit(1);
		}
		printf("step %d, rip = %lx\n", i++, ctlpc(ctl));
	}
	e = ctlwait(ctl);
	switch(e->kind){
	case Eexit:
		printf("target exited\n");
		break;
	default:
		printf("unexpected event %d\n", e->kind);
		break;
	}
	freeevent(e);
	sctlfini();
	return 0;
}
