enum Mkind
{
	/* Reserved 0 */
	Rerror = 1,
	/* Reserved 2 */
	Aevent = 3,
	Tversion,
	Rversion,
	Tping,
	Rping,
	Tps,
	Rps,
	Tlaunch,
	Rlaunch,
	Tattach,
	Rattach,
	Tstat,
	Rstat,
	Tcont,
	Rcont,
	Tstop,
	Rstop,
	Tstep,
	Rstep,
	Tsnap,
	Rsnap,
	Tkill,
	Rkill,
	Tdetach,
	Rdetach,
	Ttrace,
	Rtrace,
	Tsettrap,
	Rsettrap,
	Tclrtrap,
	Rclrtrap,
	Tgetctx,
	Rgetctx,
	Tsetctx,
	Rsetctx,
	Tread,
	Rread,
	Twrite,
	Rwrite,
	Tlooksym,
	Rlooksym,
	Tenumsym,
	Renumsym,
	Tlooktype,
	Rlooktype,
	Tenumtype,
	Renumtype,
	Tlookaddr,
	Rlookaddr,
	Tenumloc,
	Renumloc,
	Tenumseg,
	Renumseg,
	Tnames,
	Rnames,
	Tunwind1,
	Runwind1,
	Tlooksrc,
	Rlooksrc,
	Tlookpc,
	Rlookpc,
};

enum
{
	/* launch flags */
	Fstdin   = 1,		  /* redirect stdin */
	Fstdout  = (Fstdin<<1),   /* redirect stdout */
	Fstderr  = (Fstdout<<1),  /* redirect stderr */
};

typedef
struct Msg
{
	u8 op;
	u32 tag;
	u64 id;
	u64 addr;
	u64 tid;
	u64 cnt;
	u64 cid;
	u64 flags;
	u64 fd;
	void *bytes;
	u64 nbytes;
	void *raw;
} Msg;

typedef
struct Buf
{
	char *buf;
	u64 len;
	u64 max;
} Buf;

#define XRD(u,v,k) {memcpy((u),(v),(k)); (v) += (k);}

extern	char* op2str[];
void	writemsg(Chan fd, Msg *m);
Msg*	readmsg(Chan fd);
void	freemsg(Msg *m);
Buf*	mkbuf();
void	freebuf(Buf *b);
void	bufexpand(Buf *b);
void	bufset(Buf *b, u64 off, void *p, u64 n);
void	bufpush(Buf *b, void *p, u64 n);
void	bufpushs(Buf *b, char *s);
void	bufpushu8(Buf *b, u8 x);
void	bufpushu32(Buf *b, u32 x);
void	bufpushu64(Buf *b, u64 x);
