#ifdef __GNUC__
#define NORETURN	__attribute__((noreturn))
#else
#define NORETURN
#endif
enum {
	Dnone,
	Daction,
	Dmessage,
	Dpacket,
	Dall, /* must be last */
};

extern int debuglevel;
extern int ignoreg;
extern char *argv0;

/* util.c */
void		setargv0(char *p);
void		xlog(char *fmt, ...);
void		xdebug(int, char *fmt, ...);
void		xdebughex(int, char *, char *, unsigned len);
void		xfatal(char *fmt, ...) NORETURN;
void		xfatalno(char *fmt, ...) NORETURN;
void*		xmalloc(size_t size);
void*		xrealloc(void *p, size_t osz, size_t sz);
char*		xstrdup(char *s);
char*		lasterror();
void		nodelay(Chan ch);
void		reuseaddr(Chan ch);
void		cloexec(int fd);
#define bug()   xfatal("bug at %s:%d", __FILE__, __LINE__)

char*		readfile(char *file, u64 *plen);

/* hash.c */
typedef struct HT HT;
HT*		mkht();
HT*		mksht();
void		freeht(HT *ht);
void		hput(HT *ht, uptr k, void *v);
void*		hget(HT *ht, uptr k);
void		hforeach(HT *ht, void (*f)(void *u, uptr k, void *v), void *u);
unsigned long	hnent(HT *ht);
void*		hrefval(HT *ht, unsigned long idx);
int		heq(HT *ha, HT *hb);
void		hdel(HT *ht, uptr k);

/* platform-dependent */
void		killall() NORETURN;
s64		xread(Fd fd, void *buf, size_t len);
s64		xrecv(Chan ch, void *buf, size_t len);
void		xsend(Chan ch, void *buf, size_t len);
void		dumpstack();
