#include "../inc/sctl.h"
#include "../inc/err.h"
#include "../unix/unix.h"
#include "linux.h"

Ctl*
attach(int pid, char **err)
{
	Ctl *ctl;
	int st;

	if(0 > ptrace(PTRACE_ATTACH, pid, 0, 0)){
		if(err)
			*err = strerror(errno);
		return 0;
	}
	if(0 > waitpid(pid, &st, 0)){
		if(err)
			*err = strerror(errno);
		return 0;
	}
	if(!WIFSTOPPED(st))
		xfatal("attach: expected process to be stopped");

	ctl = mkctl(pid);
	ctl->state = Sstop;
	ctl->whence = Wattached;
	ctl->as = mkas(ctl);	/* FIXME: can we tell if we already have AS? */
	xgetregs(ctl, &ctl->ctx.regs);
	if(0 > syminitattach(ctl, err))
		/* FIXME: clean up ctl */
		return 0;
	xtrace(ctl, defaultevents);
	return ctl;
}
