#include "../inc/sctl.h"

static void
sigchld()
{
	/* the action is the interrupted pselect call */
}

static void
sigint(int sig)
{
	killall();
}

void
srv(int fd)
{
	sigset_t mask, omask;
	fd_set fds;
	int rv;
	Msg *m;
	Event *e;

	xdebug(Daction, "%s()", __FUNCTION__);
	sctlinit();
	cloexec(fd);
	signal(SIGINT, sigint);
	signal(SIGCHLD, sigchld);
	sigemptyset(&mask);
	sigprocmask(SIG_SETMASK, &mask, 0);
	sigaddset(&mask, SIGCHLD);
	sigprocmask(SIG_BLOCK, &mask, &omask);

	while(1){
		/* expect to be interrupted by SIGCHLDs
                   induced by events on traced procs.
                   pselect prevents lost SIGCHLDs.
		*/
		FD_ZERO(&fds);
		FD_SET(fd, &fds);
		rv = pselect(fd+1, &fds, 0, 0, 0, &omask);
		if(0 > rv && errno != EINTR)
			xfatalno("select");
		if(rv > 0){
			m = readmsg(fd);
			if(m == 0){
				closechan(fd);
				ctlrelease();
				sctlfini();
				killall();
			}
			domsg(fd, m);
			freemsg(m);
		}else{
			/* SIGCHLD interruption implies
			   that one or more events are
			   waiting */
			while((e = ctlpoll(0))){
				aevent(fd, e);
				freeevent(e);
			}
		}
	}
}
