#include "../inc/sctl.h"
#include "../inc/err.h"

u64
ctlpc(Ctl *ctl)
{
	return ctl->ctx.regs.rip;
}

void
ctlsetpc(Ctl *ctl, u64 pc)
{
	ctl->ctx.regs.rip = pc;
}

void
freectx(Ctx *c)
{
	free(c);
}

Ctx*
unpackctx(void *buf, u64 len)
{
	Ctx *ctx;
	char *p;

	ctx = xmalloc(sizeof(Ctx));
	p = buf;
	XRD(&ctx->regs, p, sizeof(ctx->regs));
	return ctx;
}

void
packctx(Buf *b, Ctx *ctx)
{
	bufpush(b, &ctx->regs, sizeof(Reg));
}

u8
execmode(Ctl *ctl)
{
	switch(ctl->ctx.regs.cs){
	case 0x23:
		return M32;
	case 0x33:
		return M64;
	default:
		xfatal("unknown execution mode (cs = %x)", ctl->ctx.regs.cs);
	}
}
