#include "../inc/sctl.h"

Buf*
mkbuf()
{
	Buf *b;
	b = xmalloc(sizeof(Buf));
	b->buf = xmalloc(1024);
	b->len = 0;
	b->max = 1024;
	return b;
}

void
freebuf(Buf *b)
{
	free(b->buf);
	free(b);
}

void
bufexpand(Buf *b)
{
	b->buf = xrealloc(b->buf, b->max, 2*b->max);
	b->max *= 2;
}

void
bufset(Buf *b, u64 off, void *p, u64 n)
{
	if(off >= b->len || off+n > b->len)
		bug();
	memcpy(&b->buf[off], p, n);
}

void
bufpush(Buf *b, void *p, u64 n)
{
	while(b->len+n > b->max)
		bufexpand(b);
	memcpy(&b->buf[b->len], p, n);
	b->len += n;
}

void
bufpushs(Buf *b, char *s)
{
	u64 n;
	n = strlen(s);
	bufpush(b, &n, sizeof(n));
	bufpush(b, s, n);
}

void
bufpushu8(Buf *b, u8 x)
{
	bufpush(b, &x, sizeof(x));
}

void
bufpushu32(Buf *b, u32 x)
{
	bufpush(b, &x, sizeof(x));
}

void
bufpushu64(Buf *b, u64 x)
{
	bufpush(b, &x, sizeof(x));
}
