#include "../inc/sctl.h"
#include "../inc/err.h"
#include "unix.h"

Ctl*
mkctl(u32 pid)
{
	Ctl *ctl;
	ctl = _mkctl(pid);
	ctl->tracemode = Eexit|Eclone|Efork|Eexec|Estepctx|Eload|Eunload|Esignal;
	return ctl;
}

void
freectl(Ctl *ctl)
{
	_freectl(ctl);
}

void
atbrkx86(Ctl *ctl)
{
	xgetregs(ctl, &ctl->ctx.regs);
	--ctl->ctx.regs.PC;    /* pc follows 1-byte trap instruction */
	xsetregs(ctl, &ctl->ctx.regs);
}

Ctx*
ctlgetctx(Ctl *ctl, char **err)
{
	Ctx *c;
	c = xmalloc(sizeof(Ctx));
	*c = ctl->ctx;
	return c;
}

int
ctlsetctx(Ctl *ctl, Ctx *c, char **err)
{
	ctl->ctx = *c;
	xsetregs(ctl, &ctl->ctx.regs);
	return 0;
}

int
resetexec(Ctl *ctl, char **err)
{
	return symresetexec(ctl, err);
}
