#include "../inc/sctl.h"

enum
{
	Maxidle = 60,		/* seconds */
};

static void
usage(void)
{
	printf("usage: sctl [options]\n");
	printf("options:\n");
	printf("     -c         start session on file descriptor 0\n");
	printf("     -d         increase debug level\n");
	printf("     -p <port>  listen for client on <port>\n");
	printf("     -g         ignore debug information in target binaries\n");
	exit(0);
}

int
main(int argc, char *argv[])
{
	unsigned short port;
	int fd, c;
	struct sockaddr_in sa, ca;
	socklen_t len;
	int pid, st, daemon = 1, stdio;
	int rv;
	fd_set fds;
	struct timeval tv;

	setargv0(argv[0]);
	port = 0;
	stdio = 0;
	ARGBEGIN{
	case 'p':
		port = (unsigned short)atoi(EARGF(usage()));
		break;
	case 'd':
		debuglevel++;
		break;
	case 'n':
		daemon = 0;
		break;
	case 'c':
		stdio++;
		break;
	case 'g':
		ignoreg++;
		break;
	case '?':
	default:
		usage();
		break;
	}ARGEND;

	/* create process group for killall */
	if(0 > setpgid(0, 0))
		xfatalno("setpgid");
	if(stdio){
		srv(0);
		exit(0);
	}
	if(port == 0)
		usage();

	memset(&sa, 0, sizeof(sa));
	sa.sin_family = AF_INET;
	sa.sin_addr.s_addr = INADDR_ANY;
	sa.sin_port = htons(port);
	fd = socket(AF_INET, SOCK_STREAM, 0);
	if(0 > fd)
		xfatalno("socket");
	reuseaddr(fd);
	if(0 > bind(fd, (struct sockaddr*)&sa, sizeof(sa)))
		xfatalno("bind");
	if(0 > listen(fd, 1))
		xfatalno("listen");
	while(1){
		FD_ZERO(&fds);
		FD_SET(fd, &fds);
		memset(&tv, 0, sizeof(tv));
		tv.tv_sec = Maxidle;
		rv = select(fd+1, &fds, 0, 0, &tv);
		rv = select(fd+1, &fds, 0, 0, 0);
		if(rv < 0 && rv == EINTR)
			continue;
		if(rv < 0)
			xfatalno("select");
		if(rv == 0)
			goto done;

		len = sizeof(ca);
		c = accept(fd, (struct sockaddr*)&ca, &len);
		if(0 > c)
			xfatalno("accept");
		nodelay(c);

		pid = fork();
		switch(pid){
		case -1:
			xfatalno("fork");
		default:
			close(c);
			waitpid(pid, &st, 0);
			continue;
		case 0:
			break;
		}

		close(fd);
		switch(fork()){
		case -1:
			xfatalno("fork");
		case 0:
			/* create process group for killall */
			if(0 > setpgid(0, 0))
				xfatalno("setpgid");
			srv(c);
			bug();
		default:
			exit(0);
		}
	}
done:
	return 0;
}
