#include "../inc/sctl.h"
#include "../inc/err.h"

void
packsiginfo(Buf *b, siginfo_t *info)
{
	/*
	  this is roughly the intersection of linux and
	  freebsd siginfo fields.

	  we haven't verified that si_value.sival_int
	  is defined on freebsd; if there is not a field
	  name in common, let's omit si_value.

	  si_trapno is not defined on linux, despite
	  what the manual says.
	*/
	bufpushu64(b, info->si_signo);
	bufpushu64(b, info->si_errno);
	bufpushu64(b, info->si_code);
	bufpushu64(b, info->si_pid);
	bufpushu64(b, info->si_uid);
	bufpushu64(b, info->si_status);
	bufpushu64(b, info->si_value.sival_int);
	bufpushu64(b, info->si_overrun);
	bufpushu64(b, info->si_timerid);
	bufpushu64(b, (uptr)info->si_addr);
	bufpushu64(b, info->si_band);
}
