#include "../inc/sctl.h"
#include "../inc/err.h"
#include "../unix/unix.h"

void
freestat(Stat *s)
{
	u64 i;
	for(i = 0; i < s->nr; i++)
		free(s->r[i].file);
	free(s->r);
	free(s->b);
	free(s);
}

void
packstat(Buf *b, Stat *s)
{
	u64 i;
	bufpushu64(b, s->pid);
	bufpushu64(b, s->nr);
	for(i = 0; i < s->nr; i++){
		bufpushs(b, s->r[i].file);
		bufpushu64(b, s->r[i].addr);
		bufpushu64(b, s->r[i].len);
		bufpushu64(b, s->r[i].flags);
	}
	bufpushu64(b, s->nb);
	for(i = 0; i < s->nb; i++){
		bufpushu64(b, s->b[i]->id);
		bufpushu64(b, s->b[i]->base);
		bufpushu8(b, s->b[i]->isexe);
		bufpushs(b, s->b[i]->path);
	}
}

Stat*
ctlstat(Ctl *ctl, char **err)
{
	Stat *s;

	s = xmalloc(sizeof(Stat));
	s->pid = (int)ctl->id;
	if(0 > parsemaps(s, err))
		goto fail;
	symstat(ctl, s);
	return s;
fail:
	freestat(s);
	return 0;
}
