#define _WIN32_WINNT _WIN32_WINNT_WINXP
#include <winsock2.h>
#include <Ws2tcpip.h>
#include <windows.h>
#include <errno.h>
#include <Psapi.h>

#pragma comment (lib, "ws2_32.lib")
/* disable warnings related to casting ints to pointers */
#pragma warning ( disable:4311)
#pragma warning ( disable:4312)
/* disable warnings regarding 'deprecated' POSIX functions */
#pragma warning ( disable:4996)

typedef CONTEXT Reg;
typedef HANDLE Fd;
typedef int ssize_t;
typedef SOCKET Chan;
typedef uintptr_t uptr;

typedef __int8            s8;
typedef __int16           s16;
typedef __int32           s32;
typedef __int64           s64;
typedef unsigned __int8   u8;
typedef unsigned __int16  u16;
typedef unsigned __int32  u32;
typedef unsigned __int64  u64;

#define snprintf sprintf_s

typedef
struct Xas
{
	int notused;
} Xas;

typedef
struct Xctl
{
	u32 pid;
	u32 tid;
	HANDLE process;
	HANDLE thread;
} Xctl;

typedef
struct Launch
{
	u64 flags;
	char *cmd;
} Launch;

typedef
struct Thread
{
	int tid;
} Thread;

typedef
struct Proc
{
	int pid;
	char *cmd;
	u64 nth;
	Thread *th;
} Proc;

typedef
struct Ps
{
	u64 npr;
	Proc *pr;
} Ps;

typedef
struct Region
{
	char *path;
	u64 base;
} Region;

typedef
struct Stat
{
	u32 state;  // 0 -> Running; 1 -> Stopped
	u64 nr;
	Region *rs;
	u64 nt;
	struct T {
		u64 id;
		u32 state;
	} *ts;
	/* FIXME: dlls */
} Stat;

typedef
struct Ctx
{
	Reg regs;
	unsigned curexn;
} Ctx;


typedef
enum Evkind
{
	Eclear	 = 0,
	Eset	 = 1,
	Esyscall = (Eset<<1),
	Eexec	 = (Esyscall<<1),
	Efork    = (Eexec<<1),
	Eclone   = (Efork<<1),
	Esignal  = (Eclone<<1),
	Eexit    = (Esignal<<1),
	Etrap    = (Eexit<<1),
	Esnap    = (Etrap<<1),
	Estepctx = (Esnap<<1),
	Eload    = (Estepctx<<1),
	Eunload  = (Eload<<1),
} Evkind;

typedef struct Event Event;
struct Event
{
	Event *link;
	Evkind kind;
	u64 id;
	union {
		struct trap {
			u64 id;
			Ctx ctx;
		} trap;
		struct spawn {
			u64 cid;
			Ctx ctx;
			Ctx cctx;
		} spawn;
		struct exit {
			int notused;
		} exit;
		struct load {
			char *path;
			u64 base;
			Ctx ctx;
		} load;
		struct unload {
			int notused;
		} unload;
		struct signal {
			Ctx ctx;
		} signal;
	} u; /* for c++ */
};

#ifdef X86_64
#define PC Rip
#else
#define PC Eip
#endif
